﻿$(document).ready(function(){ 
    $( "#volSlider" ).slider({
      value: 100,
      orientation: "horizontal",
      range: "min",
      min: 0,
      max: 100,
      animate: true,
      slide: function( event, ui ) {
        $( "#amount" ).val( ui.value );
      }
    });

    $( "#parametreButton" ).button({
      icons: {
        primary: "ui-icon-wrench"
    }
      });
    $( "#volumeParam" ).button({
      icons: {
        primary: "ui-icon-volume-on"
    }
      });
    $( "#musiqueActivD" ).button({
      icons: {
        primary: "ui-icon-play"
    }
      });
    $( "#musiqueActiv" ).button({
      icons: {
        primary: "ui-icon-pause"
    }
      });
    $( "#effetActivD" ).button({
      icons: {
        primary: "ui-icon-play"
    }
      });
    $( "#effetActiv" ).button({
      icons: {
        primary: "ui-icon-pause"
    }
      });
    $( "#reinitParam" ).button({
      icons: {
        primary: "ui-icon-refresh"
    }
      });
    $( "#reinitAll" ).button({
      icons: {
        primary: "ui-icon-trash"
    }
      });
    $( "#quitButtonPar" ).button({
      icons: {
        primary: "ui-icon-arrowreturnthick-1-w"
    }
      });
    $( "#choixDifQuit" ).button({
      icons: {
        primary: "ui-icon-arrowreturnthick-1-w"
    }
      });
    $( "#colorParam" ).button({
      icons: {
        primary: "ui-icon-image"
    }
      });
    $( ".supprHS" ).button({
      icons: {
        primary: "ui-icon-trash"
    }
      });

    audioEffet = document.createElement("audio");
    audioEffet.src = "musique/effet.mp3";
    var jstEffetAct = $.jStorage.get("effetActived");

    if(jstEffetAct == null) {
        $("#effetActiv").show();
        $("#effetActivD").hide();
    }
    else if(jstEffetAct == "Oui") {
        $("#effetActiv").show();
        $("#effetActivD").hide();
    }
    else if(jstEffetAct == "Non") {
        $("#effetActivD").show();
        $("#effetActiv").hide();
        audioEffet.muted = true;
    }

    $(":input").click(function() {
            audioEffet.play();
        });

    $(".ui-button").click(function() {
            audioEffet.play();
        });

    $("a").click(function() {
            audioEffet.play();
        });
    
    if(window.HTMLAudioElement) {
    var audio = document.createElement("audio");
    var jstMusicAct = $.jStorage.get("musiqueActived");
    var jstVolumeMusic = $.jStorage.get("musiqueVolume");
    var jstCouleurAP = $.jStorage.get("couleurAP");
    $('#colorpicker').farbtastic('#colorAP');
    colorPicker1 = $.farbtastic('#colorpicker');
    if (audio != null && audio.canPlayType && audio.canPlayType("audio/mpeg"))  
    {  
    audio.src = "musique/musique.mp3";
    audio.play();
    audio.loop = true;
    }
    else {
        $( "#musiqueActivD" ).button({ disabled: true });
        $( "#musiqueActiv" ).button({ disabled: true });
        $( "#volumeParam" ).button({ disabled: true });

        $("#musiqueActivD").show();
        $("#musiqueActiv").hide();

        $("#effetActivD").show();
        $("#effetActiv").hide();
        $( "#effetActivD" ).button({ disabled: true });
        $( "#effetActiv" ).button({ disabled: true });
    }
    
    if(jstMusicAct == "Non") {
        $("#musiqueActivD").show();
        $("#musiqueActiv").hide();
        audio.pause();
    }
    else {
    
    }
    
    if(jstVolumeMusic == null) {
        $("#amount").val("100");
        $( "#volSlider" ).slider( "value", 100);
    }
    else if(jstVolumeMusic < 0 || jstVolumeMusic > 100 || isNaN(jstVolumeMusic)) {
        $("#amount").val("100");
        $( "#volSlider" ).slider( "value", 100);
        audio.volume = 1;
        $.jStorage.set("musiqueVolume", 100);
    }
    else {
        jstVolumeMusic = parseInt(jstVolumeMusic);
        $( "#volSlider" ).slider( "value", jstVolumeMusic);
        $("#volumeInfosB").text(jstVolumeMusic);
        $("#amount").val(jstVolumeMusic);
        jstVolumeMusic = jstVolumeMusic / 100;
        audio.volume = jstVolumeMusic;
    }
    }
    else {
        $( "#musiqueActivD" ).button({ disabled: true });
        $( "#musiqueActiv" ).button({ disabled: true });
        $( "#volumeParam" ).button({ disabled: true });

        $("#musiqueActivD").show();
        $("#musiqueActiv").hide();

        $("#effetActivD").show();
        $("#effetActiv").hide();
        $( "#effetActivD" ).button({ disabled: true });
        $( "#effetActiv" ).button({ disabled: true });
    }
    
    if(jstCouleurAP != null && jstCouleurAP.charAt(0) == "#") {
        $("#zoneDuJeu").css( "background-color", jstCouleurAP );
        var contrastColor = getContrastYIQ(jstCouleurAP.substr(1));
        $("#zoneDuJeu").css( "color", contrastColor );
        $( "#colorAP" ).val(jstCouleurAP);
        colorPicker1.setColor(jstCouleurAP);
    }
    else if(jstCouleurAP == null) {
        
    }
    
    $("#parametreButton").click(function() {
        $("#ecranDebut").hide();    
        $("#parametresEcran").toggle( "slide", { direction: "right" },300);
    });
    $("#quitButtonPar").click(function() {
        $("#ecranDebut").toggle( "slide", { direction: "left" },300);   
        $("#parametresEcran").hide();
    });
    $("#musiqueActiv").click(function() {
        if(audio != null) {
        $("#musiqueActivD").show();
        $("#musiqueActiv").hide();
        audio.pause();
        $.jStorage.set("musiqueActived", "Non");
        }
    });
    $("#musiqueActivD").click(function() {
        if(audio != null) {
        $("#musiqueActiv").show();
        $("#musiqueActivD").hide();
        audio.play();
        $.jStorage.set("musiqueActived", "Oui");
        }
    });
    $("#effetActiv").click(function() {
        if(audioEffet != null) {
        $("#effetActivD").show();
        $("#effetActiv").hide();
        audioEffet.muted = true;
        $.jStorage.set("effetActived", "Non");
        }
    });
    $("#effetActivD").click(function() {
        if(audioEffet != null) {
        $("#effetActiv").show();
        $("#effetActivD").hide();
        audioEffet.muted = false;
        $.jStorage.set("effetActived", "Oui");
        }
    });
    
    $("#volumeParam").click(function() {
        dialogMusic = $( "#dialog-param-volume" ).dialog({
      show: {
        effect: "puff",
        duration: 300
      },
      autoOpen: false,
      height: 300,
      width: 450,
      modal: true,
      closeOnEscape: false,
      buttons: {
        "Valider": function() { changeVolume($( "#amount" ).val()); audioEffet.play(); $(this).dialog("close"); },
        "Annuler": function() {
          $(this).dialog("close");
            if(audioEffet != null) {
            audioEffet.play();
            }
        }
      },
      Close: function() {
            if(audioEffet != null) {
            audioEffet.play();
            }
      }
    });
    $("#dialog-param-volume").dialog("open");
    });
    
    $("#colorParam").click(function() {
        dialogColor = $( "#dialog-param-color" ).dialog({
      show: {
        effect: "puff",
        duration: 300
      },
      autoOpen: false,
      height: 435,
      width: 450,
      modal: true,
      closeOnEscape: false,
      buttons: {
        "Valider": function() { changeColor($( "#colorAP" ).val()); audioEffet.play(); $(this).dialog("close"); },
        "Annuler": function() {
          $(this).dialog("close");
          if(audioEffet != null) {
      audioEffet.play();
      }
        }
      },
      Close: function() {
      if(audioEffet != null) {
      audioEffet.play();
      }
      }
    });
    $("#dialog-param-color").dialog("open");
    });
    
    $("#colorDefault").click(function() {
        $( "#colorAP" ).val("#C8E9FE");
        colorPicker1.setColor("#C8E9FE");
    });
    
    function changeVolume(value) {
        if(audio != null) {
        var volumeC = parseInt(value);
        if(volumeC < 0 || volumeC > 100) {
            
        }
        else {
            $("#volumeInfosB").text(volumeC);
            $.jStorage.set("musiqueVolume", volumeC);
            var volumeC = volumeC / 100;
            audio.volume = volumeC;
        }
        }
    }
    
    function changeColor(value) {
            var colorC = value;
            $.jStorage.set("couleurAP", colorC);
            $("#zoneDuJeu").css( "background-color", colorC );
            var contrastColor = getContrastYIQ(colorC.substr(1));
            $("#zoneDuJeu").css( "color", contrastColor );
        }
    
    $("#reinitParam").click(function() {
        if(confirm("Êtes-vous sûr de vouloir réinitialiser les paramètres ?")) {
        $.jStorage.deleteKey("musiqueVolume");
        $.jStorage.deleteKey("musiqueActived");
        $.jStorage.deleteKey("couleurAP");
        $.jStorage.deleteKey("effetActived");
        if (audio != null && audio.canPlayType && audio.canPlayType("audio/mpeg"))  
        {  
            $("#musiqueActiv").show();
        $("#musiqueActivD").hide();
        audio.play();
        $("#amount").val("100");
        $("#volumeInfosB").text("100");
        $( "#volSlider" ).slider( "value", 100);
        audio.volume = 1;
        $("#effetActiv").show();
        $("#effetActivD").hide();
        audioEffet.muted = false;
        }
        else {
        $( "#musiqueActivD" ).button({ disabled: true });
        $( "#musiqueActiv" ).button({ disabled: true });
        $( "#volumeParam" ).button({ disabled: true });

        $("#musiqueActivD").show();
        $("#musiqueActiv").hide();

        $("#effetActivD").show();
        $("#effetActiv").hide();
        $( "#effetActivD" ).button({ disabled: true });
        $( "#effetActiv" ).button({ disabled: true });
        }
        $( "#colorAP" ).val("#C8E9FE");
        colorPicker1.setColor("#C8E9FE");
        $("#zoneDuJeu").css( "background-color", "#C8E9FE");
        var contrastColor = getContrastYIQ("C8E9FE");
        $("#zoneDuJeu").css( "color", contrastColor );
        alert("Les paramètres ont été réinitialisés.");
        }
    });
    $("#reinitAll").click(function() {
        if(confirm("Êtes-vous sûr de vouloir supprimer TOUTES les données sauvegardées ?\n\nElles ne pourront pas être récupérées.")) {
        $.jStorage.deleteKey("musiqueVolume");
        $.jStorage.deleteKey("musiqueActived");
        $.jStorage.deleteKey("bestScoreVictoires");
        $.jStorage.deleteKey("bestScoreEssais");
        $.jStorage.deleteKey("numeroDifficulteBestScore");
        $.jStorage.deleteKey("pointsBestScore");
        $.jStorage.deleteKey("pointsBestScoreDif");
        $.jStorage.deleteKey("couleurAP");
        $.jStorage.deleteKey("effetActived");
        alert("Toutes les données ont été réinitialisées. Le jeu va redémarrer.");
        window.onbeforeunload = function() {};
        location.reload(true);
        }
    });
});
